/*****************************************************************/
/*                                                               */
/*   CASIO fx-9860G SDK Library                                  */
/*                                                               */
/*   File name : [ProjectName].c                                 */
/*                                                               */
/*   Copyright (c) 2006 CASIO COMPUTER CO., LTD.                 */
/*                                                               */
/*****************************************************************/
#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <timer.h>
#include <fxlib.h>
#include "TIMER_FX2.H"
#include "KeyScan.h"
#include "FKey.h"
#include "inp.h"
#include "CB_lib.h"

//------------------------------------------------------------------------------

int FuncKeyDown()	// no key down : 0
{
	if ( *(volatile unsigned short*)0xFFFFFF80 != 0 ) 
	 return ( *((unsigned char*)0xA4000120) != 0xFF );		// SH3
	 return ( *((unsigned short*)0xA44b0008) != 0 );		// SH4A
}
//------------------------------------------------------------------------------
int KeyCheckEXIT(void)		// [EXIT]
{
	int kcode1 = 0, kcode2 = 0, flag0 = 0;
	short unused = 0;

	if ( Bkey_GetKeyWait(&kcode1,&kcode2,KEYWAIT_HALTOFF_TIMEROFF,0,1,&unused ) == KEYREP_KEYEVENT ) {
		if ( ( kcode1 == 4 ) && (kcode2 == 8 ) ) flag0=1; // [EXIT] is down
	}
	return flag0;
}

int KeyCheckDEL(void)		// [DEL]
{
	int kcode1 = 0, kcode2 = 0, flag0 = 0;
	short unused = 0;

	if ( Bkey_GetKeyWait(&kcode1,&kcode2,KEYWAIT_HALTOFF_TIMEROFF,0,1,&unused ) == KEYREP_KEYEVENT ) {
		if ( ( kcode1 == 4 ) && (kcode2 == 5 ) ) flag0=1; // [DEL] is down
	}
	return flag0;
}

int KeyCheckAC(void)		// [AC]
{
	int kcode1 = 0, kcode2 = 0, flag0 = 0;
	short unused = 0;

	if ( Bkey_GetKeyWait(&kcode1,&kcode2,KEYWAIT_HALTOFF_TIMEROFF,0,1,&unused ) == KEYREP_KEYEVENT ) {
		if ( ( kcode1 == 1 ) && (kcode2 == 1 ) ) flag0=1; // [AC] is down
	}
	return flag0;
}

int KeyCheckAC_Fast(void)		// [AC]
{
 	return ( KeyScanDown(KEYSC_AC) );
}


int KeyCheckEXE(void)		// [EXE]
{
	int kcode1 = 0, kcode2 = 0, flag0 = 0;
	short unused = 0;

	if ( Bkey_GetKeyWait(&kcode1,&kcode2,KEYWAIT_HALTOFF_TIMEROFF,0,1,&unused ) == KEYREP_KEYEVENT ) {
		if ( ( kcode1 == 3 ) && (kcode2 == 2 ) ) flag0=1; // [EXE] is down
	}
	return flag0;
}

int KeyCheckEXE_Fast(void)		// [EXE]
{
 	return ( KeyScanDown(KEYSC_EXE) );
}


//------------------------------------------------------------------------------
#define		wAry 10000

void BugTrap(int flag, int buglen)
{
	char minimsg[]={'E','X','E','/',0xE6,0x91,'/',0xE6,0x92,'/',0xE6,0x90,'/',0xE6,0x93,':',' ','D','r','a','w',' ','W','a','l','l',0};
	char buffer[21];
	unsigned int key;
	int i;
	char wX[wAry],wY[wAry];
	int buglen_loop=0;
	int	buglen_1stPtr=0;
	int	buglen_endPtr=0;

	if ( flag ) {
		for (i=0; i<=buglen ; i++) {
			wX[i]=0;
			wY[i]=0;
		}
	}
	while ( FuncKeyDown() );
	Bdisp_AllClr_DDVRAM();

	Coord= 1;	// Coord on
	Grid=  0;	// Grid on
	Axes=  0;	// Axes on
	Label= 0;	// Label on
	
//	ViewWindow(0,126,0, 0,62,0);
//	ViewWindow(0,126,0, 62,0,0);
//	ViewWindow(1,127,0, 63,1,0);
	ViewWindow(E,  F,0,  G,H,0);
	
	//==Draw frame==
	Horizontal( Ymin ,S_L_Normal);
	Vertical(   Xmax ,S_L_Normal);
	Horizontal( Ymax ,S_L_Normal);
	Vertical(   Xmin ,S_L_Normal);
	
	//==Paint mode==
//	Text(  7, 3, "EXE////: Draw Wall");
	Text(  7, 3, minimsg);
	Text( 13, 3, "DEL:Go!");

	while (1) {
		GetKey(&key);
		if (key==KEY_CTRL_EXIT) break;
		if (key==KEY_CTRL_DEL) {
				while ( KeyCheckDEL() );
				break;
		}
		if (key==KEY_CTRL_EXE) {
			while ( KeyCheckEXE() ); 
			Text( 13, 3, "        ");
			Plot(X,Y);
			Line(S_L_Default);
			Text( 13, 3, "DEL:Go!");
		}
		if (key==KEY_CTRL_OPTN) {
			RestoreDisp(SAVEDISP_PAGE2);	// ------ RestoreDisp2
		}
	} 
	Text(  7, 3, "                           ");
	Text( 13, 3, "        ");
	Bdisp_PutDisp_DD();

	//==Draw dot==
	B=62,A=2,D=-1,C=1;
	PxlOn_DDVRAM(B, A);
	
	//==Move dot==
	SaveDisp(SAVEDISP_PAGE2);	// ------ SaveDisp2
	
	while (1) {
		//*Set direction
		if ( (B<=1) || (B>= 63) ) D=-D;
		else
		if ( (A<=1) || (A>=126) ) C=-C;
		else {
			if ( PxlTest(B+D,A) ) D=-D;
			if ( PxlTest(B,A+C) ) C=-C;
		}
		//*Plot dot
		B=B+D;
		A=A+C;
		PxlOn_VRAM(B, A);
		
		if ( flag ){		// BugTrap only
			wX[buglen_1stPtr]=A; wY[buglen_1stPtr]=B;
			buglen_1stPtr++; if (buglen_1stPtr > buglen) { buglen_1stPtr=0; buglen_loop=1; }
			if ( buglen_loop ) { 
				PxlOff_VRAM( wY[buglen_endPtr], wX[buglen_endPtr] );
				buglen_endPtr++; if (buglen_endPtr > buglen) buglen_endPtr=0;
			}
		}

		Bdisp_PutDisp_DD();

		DrawBusy();	// Running indicator
		
		if ( KeyCheckEXIT() ) break;	// break;
	}

	if ( flag ){		// BugTrap only
		for (i=0; i<=buglen ; i++) PxlOff_VRAM( wY[i], wX[i] );
	}
	SaveDisp(SAVEDISP_PAGE3);	// ------ SaveDisp3
}

//------------------------------------------------------------------------------
void DrunkBug()
{
	char buffer[21];
	unsigned int key;

	while ( FuncKeyDown() );
	Bdisp_AllClr_DDVRAM();

	Coord= 1;	// Coord on
	Grid=  0;	// Grid on
	Axes=  0;	// Axes on
	Label= 0;	// Label on
	
	ViewWindow(0,126,0,0,62,0);

	Text(1, 1, "EXE: Start");
	Bdisp_PutDisp_DD();
	while ( 1) {
		GetKey(&key);
		if (key==KEY_CTRL_EXE) {
			while ( KeyCheckEXE() );
			break;
		}
	}

	Text(1, 1, "EXIT: Quit    ");
	Bdisp_PutDisp_DD();

	while (1) {
		P=floor(rand()*10/(RAND_MAX+1.0));
		Q=floor(rand()*10/(RAND_MAX+1.0));

		if ( P/2-floor(P/2) ) {	if (X>=126) X-=2; 
					X+=1;
				}
		else {		if (X<=0) X+=2;
					X-=1;
			}
		if ( Q/2-floor(Q/2) ) {	if (Y>=62) Y-=2; 
					Y+=1;
				}
		else {		if (Y<=0) Y+=2;
					Y-=1;
			}

		PlotChg_VRAM( X, Y);
		
		Bdisp_PutDisp_DD();

		DrawBusy();	// Running indicator
		
		if ( KeyCheckEXIT() ) break;	// break;
	}
	SaveDisp(SAVEDISP_PAGE3);	// ------ SaveDisp3
}


//------------------------------------------------------------------------------

void DLINE(){
	char buffer[21];
	unsigned int key;

	while ( FuncKeyDown() );
	Bdisp_AllClr_DDVRAM();

	Coord= 1;	// Coord on
	Grid=  0;	// Grid on
	Axes=  0;	// Axes on
	Label= 0;	// Label on
	
	ViewWindow(0,126,0,0,62,0);

	for ( Y=0; Y<=62; Y++){
		F_Line( 126,Y, Y+46,Y, S_L_Default);
		DrawBusy();	// Running indicator
	}
	for ( Y=0; Y<=62; Y+=2){
		F_Line( 0,Y, Y+16,Y, S_L_Default);
		DrawBusy();	// Running indicator
	}
	SaveDisp(SAVEDISP_PAGE3);	// ------ SaveDisp3
	GetKey(&key);
}
//------------------------------------------------------------------------------

void LINE_test(){
	char buffer[21];
	unsigned int key;

	while ( FuncKeyDown() );
	Bdisp_AllClr_DDVRAM();

	ViewWindow(Xmin,Xmax,Xscl,Ymin,Ymax,Yscl);

	F_Line( X,Y, V,W, S_L_Default);
	Bdisp_PutDisp_DD();
	while (1) {
		sprintf(buffer,"X=%g Y=%g V=%g W=%g", X, Y, V, W);
		PrintMini(0,0,(unsigned char*)buffer,MINI_OVER);
		GetKey(&key);
		if (key==KEY_CTRL_EXIT) break;
		if (key==KEY_CTRL_EXE) {
			while ( KeyCheckEXE() ); 
			V=X; W=Y;
			if ( Plot(X,Y) ) break;
			Line(S_L_Default);
			Bdisp_PutDisp_DD();
		}
	} 
	SaveDisp(SAVEDISP_PAGE3);	// ------ SaveDisp3
}
//------------------------------------------------------------------------------
int Graphflag=0;

void Graphfunc_drawfunc_sub(){
	int i;
	double x;

	Bdisp_AllClr_DDVRAM();
	ViewWindow( Xmin, Xmax, Xscl, Ymin, Ymax, Yscl);
	x=Xmin-Xdot;
	for ( i=0; i<=128; i++) {
		//-----------------------------
		traceAry[i]=sin(x);		// function
//		traceAry[i]=x;
		//-----------------------------
		if ( fabs(traceAry[i])<1.0e-13 ) traceAry[i]=0;	// zero adjust
		if ( ( 0<i ) && ( i<128 ) ) {
			PlotOn_VRAM( x, traceAry[i] );
			if ( DrawType == 0 ) Line(S_L_Default);
			Bdisp_PutDisp_DD();
		}
		DrawBusy();	// Running indicator
		x+=Xdot;
	}
	SaveDisp(SAVEDISP_PAGE1);	// ------ SaveDisp1
}

void Graphfunc_zoom_sub(){
	char buffer[32];
	unsigned int key;
	double x,y;

	Fkey_dispR( 1, "FACT");
	Fkey_dispN( 2, " IN");
	Fkey_dispN( 3, "OUT");
	GetKey(&key);
	switch (key) {
		case KEY_CTRL_EXIT:
			break;
		case KEY_CTRL_F2:
			SetFactor();
			break;
		case KEY_CTRL_F3:
			RestoreDisp(SAVEDISP_PAGE1);	// ------ RestoreDisp1
			ZoomIn();
			break;
		case KEY_CTRL_F4:
			RestoreDisp(SAVEDISP_PAGE1);	// ------ RestoreDisp1
			ZoomOut();
			break;
		default:
		break;
	}
	Graphfunc_drawfunc_sub();
}

void Graphfunc_trace_sub(int *tracex){
	int f;
	int tx,ty; // dummy
	tx=*tracex;
	while (1) {
		if  ( tx <   1 ) tx=  0;
		if  ( tx > 127 ) tx=128;
		f=Trace(&tx);
		if ( f == -1 ) break; //exit
		if ( f == 2  ) { // F2
			Graphfunc_zoom_sub();
			Graphfunc_drawfunc_sub();
			break;
		}
		if ( f == 3  ) { // F3
			SetViewWindow();
			Graphfunc_drawfunc_sub();
			break;
		}
		if ( f <= -1000) { 
			Xmin-=Xdot*8;
			Xmax-=Xdot*8;
			Graphfunc_drawfunc_sub();
			VWtoPXY(Xmin+Xdot*7, 0, &tx, &ty);
		}
		if ( f >= 1000) { 
			Xmin+=Xdot*8;
			Xmax+=Xdot*8;
			Graphfunc_drawfunc_sub();
			VWtoPXY(Xmax-Xdot*7, 0, &tx, &ty);
		}
	}
	*tracex=tx;
}

void Graphfunc_test(){
	char buffer[21];
	unsigned int key;
	int cont=1;
	int tx=64;	// trace center 

	while ( FuncKeyDown() );
	Bdisp_AllClr_DDVRAM();

	Coord= 1;	// Coord on
	Grid=  1;	// Grid on
	Axes=  1;	// Axes on
	Label= 1;	// Label on
	
	if (Graphflag==0) SetVeiwWindowTrig();
	Graphflag=1;
	Graphfunc_drawfunc_sub();
	
	while (cont) {
		GetKey(&key);
		switch (key) {
			case KEY_CTRL_EXIT:
				cont=0;
				break;
			case KEY_CTRL_LEFT:
				Xmin-=Xdot*12;
				Xmax-=Xdot*12;
				Graphfunc_drawfunc_sub();
				break;
			case KEY_CTRL_RIGHT:
				Xmin+=Xdot*12;
				Xmax+=Xdot*12;
				Graphfunc_drawfunc_sub();
				break;
			case KEY_CTRL_UP:
				Ymin+=Ydot*12;
				Ymax+=Ydot*12;
				Graphfunc_drawfunc_sub();
				break;
			case KEY_CTRL_DOWN:
				Ymin-=Ydot*12;
				Ymax-=Ydot*12;
				Graphfunc_drawfunc_sub();
				break;
			case KEY_CTRL_SHIFT:
				Fkey_dispN( 0, "TRCE");
				Fkey_dispR( 1, "ZOOM");
				Fkey_dispR( 2, "V-W");
				GetKey(&key);
				switch (key) {
					case KEY_CTRL_EXIT:
						break;
					case KEY_CTRL_SETUP:
						SetupG();
						Graphfunc_drawfunc_sub();
						break;
					case KEY_CTRL_F1:
						RestoreDisp(SAVEDISP_PAGE1);	// ------ RestoreDisp1
						Graphfunc_trace_sub(&tx);
						break;
					case KEY_CTRL_F2:
						RestoreDisp(SAVEDISP_PAGE1);	// ------ RestoreDisp1
						Graphfunc_zoom_sub();
						break;
					case KEY_CTRL_F3:
						SetViewWindow();
						Graphfunc_drawfunc_sub();
						break;
					default:
					break;
				}
				RestoreDisp(SAVEDISP_PAGE1);	// ------ RestoreDisp1
				break;
			case KEY_CTRL_F1:
				RestoreDisp(SAVEDISP_PAGE1);	// ------ RestoreDisp1
				Graphfunc_trace_sub(&tx);
				break;
			case KEY_CTRL_F2:
				RestoreDisp(SAVEDISP_PAGE1);	// ------ RestoreDisp1
				Graphfunc_zoom_sub();
				break;
			case KEY_CTRL_F3:
				SetViewWindow();
				Graphfunc_drawfunc_sub();
				break;
			default:
				break;
		}
		
		Bdisp_PutDisp_DD();
	}

	SaveDisp(SAVEDISP_PAGE3);	// ------ SaveDisp3
}


//****************************************************************************
//  AddIn_main (Sample program main function)
//
//  param   :   isAppli   : 1 = This application is launched by MAIN MENU.
//                        : 0 = This application is launched by a strip in eACT application.
//
//              OptionNum : Strip number (0~3)
//                         (This parameter is only used when isAppli parameter is 0.)
//
//  retval  :   1 = No error / 0 = Error
//
//****************************************************************************
int AddIn_main(int isAppli, unsigned short OptionNum)
{
	unsigned int key;
	int cont=1;
	int buglen=9;	// Bug length ( Bug Trap only )
	char buffer[22];
    char *onoff[]  ={"off","on"};
    char *style[]  ={"Normal","Thick","Broken","Dot"};
	
	ViewWindow(0,126,0,0,62,0);
	E=0; F=126;  G=0; H=62;	

	while( cont ) {
		Bdisp_AllClr_DDVRAM();
		PrintMini(108, 1, (unsigned char*)"v2.00",0);
		locate(1,1);Print((unsigned char*)"F1:Bug Trace");
		locate(1,2);Print((unsigned char*)"F2:Bug Trap");
			locate(13,2); sprintf(buffer,"(%4d)",buglen); Print((unsigned char*)buffer);
		locate(1,3);Print((unsigned char*)"F3:Drunk Bug");
		locate(1,4);Print((unsigned char*)"F4:DLINE");
		locate(1,5);Print((unsigned char*)"F5:LINE_Test");		
		locate(1,6);Print((unsigned char*)"F6:Graph test");

		locate( 1, 7); Print((unsigned char*)"Style:");
//		locate( 7, 7); Print((unsigned char*)style[S_L_Style]);
		locate( 7, 7); Print((unsigned char*)"[    ]"); Linesub( 43, 52, 65, 52, S_L_Default);
		locate(14, 7); Print((unsigned char*)"Busy:");
		locate(19, 7); Print((unsigned char*)onoff[BusyInd]);

		Fkey_dispN( 0, "Trac");
		Fkey_dispN( 1, "Trap ");
		Fkey_dispN( 2, "Drk");
		Fkey_dispN( 3, "Dlin");
		Fkey_dispN( 4, "Line");
		Fkey_dispN( 5, "Grph");
		
		GetKey(&key);
		switch (key) {
//			case KEY_CTRL_EXIT:
//				cont=0;
//				break;
			case KEY_CTRL_SHIFT:
				Fkey_dispR( 0, "Styl");
				Fkey_Clear( 1 );
				Fkey_dispR( 2, "V-W");
				Fkey_Clear( 3 );
				Fkey_Clear( 4 );
				Fkey_dispN( 5, "RPic");
				GetKey(&key);
				switch (key) {
					case KEY_CTRL_EXIT:
						break;
					case KEY_CTRL_SETUP:
						SetupG();
						break;
					case KEY_CTRL_F1:
						SetLineStyle();
						break;
					case KEY_CTRL_F3:
						SetViewWindow();
						break;
					case KEY_CTRL_F6:
						RestoreDisp(SAVEDISP_PAGE3);	// ------ RestoreDisp3
						while (key!=KEY_CTRL_EXIT) GetKey(&key);
						break;
					default:
					break;
				}
				break;
			case KEY_CTRL_F1:
				BugTrap(0,buglen);
				break;
			case KEY_CTRL_F2:
				buglen=InputNumD(14,2, 4, buglen, ' ',REV_OFF, FLOAT_OFF,  EXP_OFF);	// 
				if ( buglen < 1 ) buglen=1;
				BugTrap(1,buglen);
				break;
			case KEY_CTRL_F3:
				DrunkBug();
				break;
			case KEY_CTRL_F4:
				DLINE();
				break;
			case KEY_CTRL_F5:
				LINE_test();
				break;
			case KEY_CTRL_F6:
				Graphfunc_test();
				break;
				
			case KEY_CTRL_OPTN:
				SetVar(4);	// E -
				break;
			case KEY_CTRL_VARS:
				SetVar(0);	// A - 
				break;
			case KEY_CTRL_XTT:
				SetVar(23);		// X -
				break;
			case KEY_CHAR_POW:
				BusyInd = BusyInd? 0 : 1;
				break;
			default:
				break;
		}
	}

	return 1;
}




//****************************************************************************
//**************                                              ****************
//**************                 Notice!                      ****************
//**************                                              ****************
//**************  Please do not change the following source.  ****************
//**************                                              ****************
//****************************************************************************


#pragma section _BR_Size
unsigned long BR_Size;
#pragma section


#pragma section _TOP

//****************************************************************************
//  InitializeSystem
//
//  param   :   isAppli   : 1 = Application / 0 = eActivity
//              OptionNum : Option Number (only eActivity)
//
//  retval  :   1 = No error / 0 = Error
//
//****************************************************************************
int InitializeSystem(int isAppli, unsigned short OptionNum)
{
    return INIT_ADDIN_APPLICATION(isAppli, OptionNum);
}

#pragma section

