/*
===============================================================================

 Casio Basic RUNTIME library for fx-9860G series      v0.01

===============================================================================
*/

//-----------------------------------------------------------------------------
// Casio Basic inside
//-----------------------------------------------------------------------------
extern int	BusyInd   ;	// BusyInd=0: running indicator off,  BusyInd=1: on

extern int	DrawType  ;	// 0:connect  1:Plot
extern int	Coord     ;	// 0:off 1:on
extern int	Grid      ;	// 0:off 1:on
extern int	Axes      ;	// 0:off 1:on
extern int	Label     ;	// 0:off 1:on
extern int	Derivative     ;	// 0:off 1:on

#define S_L_Normal   0
#define S_L_Thick    1
#define S_L_Broken   2
#define S_L_Dot      3
#define S_L_Default  -1

extern int S_L_Style;		// set line style 

extern double Previous_X;	// ViewWindow Previous XY
extern double Previous_Y;	// ViewWindow Previous XY

//-----------------------------------------------------------------------------
// Casio Basic Gloval variable
//-----------------------------------------------------------------------------

extern double A;
extern double B;
extern double C;
extern double D;
extern double E;
extern double F;
extern double G;
extern double H;
extern double I;
extern double J;
extern double K;
extern double L;
extern double M;
extern double N;
extern double O;
extern double P;
extern double Q;
extern double R;
extern double S;
extern double T;
extern double U;
extern double V;
extern double W;
extern double X;		// ViewWindow Current  X
extern double Y;		// ViewWindow Current  Y
extern double Z;

extern double	Xmin;		// ViewWindow
extern double	Xmax;		// ViewWindow
extern double	Xscl;		// ViewWindow
extern double	Xdot;		// ViewWindow
extern double	Ymin;		// ViewWindow
extern double	Ymax;		// ViewWindow
extern double	Yscl;		// ViewWindow
extern double	Ydot;		// ViewWindow
extern double	TThetamin;	// ViewWindow
extern double	TThetamax;	// ViewWindow
extern double	TThetaptch;	// ViewWindow

extern	double	Xfct;					// 
extern	double	Yfct;					// 

extern double	traceAry[130];		// Graph trace array

//-----------------------------------------------------------------------------
void Text(int y, int x, char*str);

//-----------------------------------------------------------------------------
int VWtoPXY(double x, double y, int *px, int *py);	// ViewWwindow(x,y) -> pixel(x,y)

void ViewWindow( double xmin, double xmax, double xscl, double ymin, double ymax, double yscl);
void ZoomIn();
void ZoomOut();

void PlotOn_VRAM(double x, double y);

void PlotOn_DD(double x, double y);

void PlotOn_DDVRAM(double x, double y);

void PlotOff_VRAM(double x, double y);

void PlotOff_DD(double x, double y);

void PlotOff_DDVRAM(double x, double y);

void PlotChg_VRAM(double x,  double y);

void PlotChg_DDVRAM(double x, double y);


void Line(int style);

void F_Line(double x1, double y1, double x2, double y2, int style);

void Vertical(double x ,int style);

void Horizontal(double y, int style);

int Plot(double X, double Y);

int Trace(int *index );

//------------------------------------------------------------------------------
void PxlOn_VRAM(int py, int px);

void PxlOn_DD(int py, int px);

void PxlOn_DDVRAM(int py, int px);

void PxlOff_VRAM(int py, int px);

void PxlOff_DD(int py, int px);

void PxlOff_DDVRAM(int py, int px);

int PxlTest(int py, int px);

//------------------------------------------------------------------------------
void SetVeiwWindowInit();
void SetVeiwWindowTrig();
void SetVeiwWindowSTD();

void SetViewWindwo(void);

void SetVar(int select);
